require 'net/ssh'

module Net
  module SSH #:nodoc:
    SSH.singleton_class.send(:alias_method, :original_start, :start) # TODO: any way to use prepend instead?

    # Custom behaviour for localhost with no user: nothing to log in with
    def self.start(host, user=nil, options={}, &block)
      return original_start(host, user, options, &block) unless host == 'localhost' && user.nil?

      transport = Transport::Session.new(host, options)
      connection = Connection::Session.new(transport, {})      
      return connection unless block_given?

      yield connection
    end
  end
end
